/**************************************************************************

	ns

	func_api.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_string.h"
#include "script_memory.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_callapi

	APIĂяo

******************************************************************************/

int SFUNC _sfunc_callapi(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	TCHAR *lib;
	TCHAR *func;
	LIBFUNC lpFunction;
	HANDLE hModul;
	long i;

	if(param == NULL){
		return -2;
	}
	lib = TGetValueString(param->v);
	if((param = param->next) == NULL){
		return -2;
	}
	func = TGetValueString(param->v);

	hModul = LoadLibrary(lib);
	lpFunction = GetProcAddress(hModul, func);

	while((param = param->next) != NULL){
		if(param->v->Type == TYPE_INTEGER){
			i = param->v->u.iValue;
		}else{
			i = (long)param->v->u.Value;
		}
		_asm mov eax, i
		_asm push eax
	}
    _asm call [lpFunction]

//	_asm mov i, eax
//	ret->v->u.iValue = i;
//	ret->v->Type = TYPE_INTEGER;

	FreeLibrary(hModul);
	return 0;
}
/* End of source */
